require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.Intent"
import "android.net.Uri"
import "android.app.AlertDialog"
import "android.content.pm.PackageManager"

activity.setTheme(android.R.style.Theme_DeviceDefault_Light_NoActionBar)
activity.setTitle("البحث")

mainLayout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  padding = "16dp",
  gravity = "center",
  {
    TextView,
    text = "البحث",
    textSize = "24sp",
    textColor = 0xFF000000,
    layout_marginBottom = "24dp"
  },
  {
    EditText,
    id = "searchBox",
    hint = "أدخل ما تريد البحث عنه",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    textSize = "18sp"
  },
  {
    Button,
    text = "ابحث",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "16dp",
    onClick = function()
      local query = searchBox.getText().toString()
      if query ~= "" then
        local url = "https://www.google.com/search?q="..Uri.encode(query)
        local intent = Intent(Intent.ACTION_VIEW)
        intent.setData(Uri.parse(url))
        activity.startActivity(intent)
      else
        Toast.makeText(activity, "الرجاء إدخال كلمة للبحث", Toast.LENGTH_SHORT).show()
      end
    end
  },
  {
    Button,
    text = "البحث بطريقة أخرى",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local query = searchBox.getText().toString()
      if query ~= "" then
        local url = "https://www.youtube.com/results?search_query="..Uri.encode(query)
        local intent = Intent(Intent.ACTION_VIEW)
        intent.setData(Uri.parse(url))
        activity.startActivity(intent)
      else
        Toast.makeText(activity, "الرجاء إدخال كلمة للبحث", Toast.LENGTH_SHORT).show()
      end
    end
  },
  {
    Button,
    text = "البحث في متجر بلاي",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local query = searchBox.getText().toString()
      if query ~= "" then
        local url = "https://play.google.com/store/search?q="..Uri.encode(query).."&c=apps"
        local intent = Intent(Intent.ACTION_VIEW)
        intent.setData(Uri.parse(url))
        activity.startActivity(intent)
      else
        Toast.makeText(activity, "الرجاء إدخال كلمة للبحث", Toast.LENGTH_SHORT).show()
      end
    end
  },
  {
    TextView,
    text = "اقتراحات",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    textSize = "18sp",
    textColor = 0xFF888888,
    layout_marginTop = "16dp"
  },
  {
    Button,
    text = "البحث عن الأدعية والزيارات",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local items = {"YouTube", "متجر بلاي"}
      AlertDialog.Builder(activity)
        .setTitle("اختر طريقة البحث عن الأدعية والزيارات:")
        .setItems(items, function(dialog, which)
          local query = "الأدعية والزيارات"
          local url
          if which == 0 then
            url = "https://www.youtube.com/results?search_query="..Uri.encode(query)
          elseif which == 1 then
            url = "https://play.google.com/store/search?q="..Uri.encode(query).."&c=apps"
          end
          local intent = Intent(Intent.ACTION_VIEW)
          intent.setData(Uri.parse(url))
          activity.startActivity(intent)
        end)
        .show()
    end
  },
  {
    Button,
    text = "البحث عن مطور الأداة",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      AlertDialog.Builder(activity)
        .setTitle("مطوروا الأداة")
        .setMessage("المطورون: محمد حسين العراقي وعلي محمد البحريني")
        .setPositiveButton("حسناً", nil)
        .show()
    end
  },
  {
    Button,
    text = "البحث عن القرآن الكريم",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local items = {"YouTube", "متجر بلاي"}
      AlertDialog.Builder(activity)
        .setTitle("أين تريد البحث عن القرآن الكريم؟")
        .setItems(items, function(dialog, which)
          local query = "القرآن الكريم"
          local url
          if which == 0 then
            url = "https://www.youtube.com/results?search_query="..Uri.encode(query)
          elseif which == 1 then
            url = "https://play.google.com/store/search?q="..Uri.encode(query).."&c=apps"
          end
          local intent = Intent(Intent.ACTION_VIEW)
          intent.setData(Uri.parse(url))
          activity.startActivity(intent)
        end)
        .show()
    end
  },
  {
    Button,
    text = "البحث عن قنوات مفيدة",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local items = {
        "زاد الحروف",
        "يوميات واحد عراقي",
        "يوميات واحد قيمري"
      }
      local urls = {
        "https://youtube.com/@zadalhorof?si=2YN33LrN0GDFqie-",
        "https://youtube.com/@one_iraqi_diary?si=tmfyJjkqYyxvYapw",
        "https://youtube.com/@gamingonedaily?si=QZc7rX9DIwgj4HRL"
      }
      AlertDialog.Builder(activity)
        .setTitle("اختر القناة")
        .setItems(items, function(dialog, which)
          local url = urls[which + 1]
          local intent = Intent(Intent.ACTION_VIEW)
          intent.setData(Uri.parse(url))
          activity.startActivity(intent)
        end)
        .show()
    end
  },
  {
    Button,
    text = "البحث عن التطبيقات",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local apps = {
        {"WhatsApp", "com.whatsapp"},
        {"Telegram", "org.telegram.messenger"},
        {"Viber", "com.viber.voip"},
        {"Facebook", "com.facebook.katana"},
        {"Messenger", "com.facebook.orca"},
        {"Instagram", "com.instagram.android"},
        {"Google Meet", "com.google.android.apps.meetings"},
        {"Twitter", "com.twitter.android"}
      }

      local names = {}
      for i, app in ipairs(apps) do
        table.insert(names, app[1])
      end

      AlertDialog.Builder(activity)
        .setTitle("اختر التطبيق")
        .setItems(names, function(dialog, which)
          local package = apps[which + 1][2]
          local intent = activity.getPackageManager().getLaunchIntentForPackage(package)
          if intent then
            activity.startActivity(intent)
          else
            local url = "https://play.google.com/store/apps/details?id="..package
            local intent = Intent(Intent.ACTION_VIEW)
            intent.setData(Uri.parse(url))
            activity.startActivity(intent)
          end
        end)
        .show()
    end
  },
  {
    Button,
    text = "البحث عن الألعاب",
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_marginTop = "8dp",
    onClick = function()
      local games = {
        "لعبة تقمص الأدوار الخاملة 1",
        "لعبة تقمص الأدوار الخاملة 5",
        "لعبة الطاولة"
      }
      local urls = {
        "https://play.google.com/store/apps/details?id=com.vaultomb",
        "https://play.google.com/store/apps/details?id=com.warshovel",
        "https://play.google.com/store/apps/details?id=net.blindgamers.tableex"
      }

      AlertDialog.Builder(activity)
        .setTitle("اختر اللعبة")
        .setItems(games, function(dialog, which)
          local url = urls[which + 1]
          local intent = Intent(Intent.ACTION_VIEW)
          intent.setData(Uri.parse(url))
          activity.startActivity(intent)
        end)
        .show()
    end
  }
}

activity.setContentView(loadlayout(mainLayout))